diff --git a/include/aircrack-ng/third-party/eapol.h b/include/aircrack-ng/third-party/eapol.h
index 5d791db1f..5da614392 100644
--- a/include/aircrack-ng/third-party/eapol.h
+++ b/include/aircrack-ng/third-party/eapol.h
@@ -17,6 +17,8 @@ struct WPA_hdsk
 	uint8_t found;
 	uint8_t eapol_source;
 	uint64_t replay;
+	int32_t tv_sec;
+	int32_t tv_usec;
 };
 
 #endif // _NET_EAPOL_H_
diff --git a/src/aircrack-ng/aircrack-ng.c b/src/aircrack-ng/aircrack-ng.c
index 30b73d3bc..c8a6b5f07 100644
--- a/src/aircrack-ng/aircrack-ng.c
+++ b/src/aircrack-ng/aircrack-ng.c
@@ -1574,6 +1574,9 @@ static int packet_reader__update_ap_info(struct AP_info * ap_cur,
 	{
 		memcpy(st_cur->wpa.anonce, &h80211[z + 17], sizeof(st_cur->wpa.anonce));
 
+		st_cur->wpa.tv_sec  = pkh->tv_sec;
+		st_cur->wpa.tv_usec = pkh->tv_usec;
+
 		/* authenticator nonce set */
 		st_cur->wpa.state = 1;
 
@@ -1604,6 +1607,18 @@ static int packet_reader__update_ap_info(struct AP_info * ap_cur,
 		&& (h80211[z + 6] & 0x80) == 0
 		&& (h80211[z + 5] & 0x01) != 0)
 	{
+		if ((st_cur->wpa.found & (1 << 1)) == (1 << 1))
+		{
+			if (st_cur->wpa.tv_sec != 0 && (pkh->tv_sec - st_cur->wpa.tv_sec) >= 5)
+			{
+				st_cur->wpa.state &= ~1;
+				st_cur->wpa.found &= ~(1 << 1);
+			}
+		}
+
+		st_cur->wpa.tv_sec  = pkh->tv_sec;
+		st_cur->wpa.tv_usec = pkh->tv_usec;
+
 		if (st_cur->wpa.state == 0)
 		{
 			// no M1; so we store the M2 replay counter.
@@ -1683,6 +1698,17 @@ static int packet_reader__update_ap_info(struct AP_info * ap_cur,
 		&& (h80211[z + 5] & 0x01) != 0
 		&& st_cur->wpa.replay < replay_counter)
 	{
+		if ((st_cur->wpa.found & (1 << 1 | 1 << 2)) != 0)
+		{
+			if (st_cur->wpa.tv_sec != 0 && (pkh->tv_sec - st_cur->wpa.tv_sec) >= 5)
+			{
+				st_cur->wpa.state &= ~(1 | 2);
+				st_cur->wpa.found &= ~(1 << 1 | 1 << 2);
+			}
+		}
+		st_cur->wpa.tv_sec  = pkh->tv_sec;
+		st_cur->wpa.tv_usec = pkh->tv_usec;
+
 		st_cur->wpa.found |= 1 << 3;
 		// Store M3 for comparison with M4.
 		st_cur->wpa.replay = replay_counter;
